"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.calcNextRun = exports.sleep = void 0;
const cron_schedule_1 = require("cron-schedule");
const sleep = (ms) => new Promise((r) => setTimeout(r, ms));
exports.sleep = sleep;
const calcNextRun = (schedule, lastRun = new Date()) => {
    const t = Math.max(lastRun.getTime(), Date.now());
    if ('milliseconds' in schedule) {
        return new Date(t + schedule.milliseconds);
    }
    if ('seconds' in schedule) {
        return new Date(t + schedule.seconds * 1000);
    }
    if ('minutes' in schedule) {
        return new Date(t + schedule.minutes * 60 * 1000);
    }
    if ('hours' in schedule) {
        return new Date(t + schedule.hours * 60 * 60 * 1000);
    }
    if ('days' in schedule) {
        return new Date(t + schedule.days * 24 * 60 * 60 * 1000);
    }
    return (0, cron_schedule_1.parseCronExpression)(schedule.cron).getNextDate(new Date(t));
};
exports.calcNextRun = calcNextRun;
