import { Scheduler } from '.';
import { JobExecuteOptions, LocalJobImplementation, LocalJobOptions } from './types';
export declare class LocalJob<Data, Result> {
    readonly scheduler: Scheduler;
    readonly implementation: LocalJobImplementation<Data, Result>;
    static DEFAULT_MAX_PARALLEL: number;
    private q;
    private handles;
    private hasShutDown;
    private executionIds;
    readonly options: LocalJobOptions<Data>;
    constructor(scheduler: Scheduler, implementation: LocalJobImplementation<Data, Result>, { maxParallel, retryCount, retryDelay, log, ...otherOptions }?: Partial<LocalJobOptions<Data>>);
    private schedule;
    execute(...[data, { delay, executionId }]: null extends Data ? [data?: null, options?: JobExecuteOptions] : [data: Data, options?: JobExecuteOptions]): Promise<Result>;
    shutdown(): Promise<void>;
    private sleep;
}
